package com.compo.camera.activities.starting;

import android.app.Activity;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.MotionEvent;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;

import com.compo.camera.R;

public abstract class StartingActivity extends Activity
{
	private MediaPlayer theme;

	private void startGame()
	{
		this.startActivity(getMainIntent());
		this.finish();
	}

	protected int getMainContentId()
	{
		return R.layout.activity_disclose_starting;
	}

	protected int getContentId()
	{
		return R.id.content;
	}

	protected int getImageViewId()
	{
		return R.id.starting;
	}

	protected abstract Intent getMainIntent();

	protected abstract int getThemeId();

	protected abstract int getImageResourceId();

	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.getWindow().setFlags(
				WindowManager.LayoutParams.FLAG_FULLSCREEN | WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON,
				WindowManager.LayoutParams.FLAG_FULLSCREEN);

		this.setContentView(this.getMainContentId());

		this.theme = MediaPlayer.create(this, this.getThemeId());
		this.theme.setLooping(true);
		this.theme.start();

		View view = this.findViewById(this.getContentId());
		view.setOnTouchListener(new View.OnTouchListener()
		{
			@Override
			public boolean onTouch(View v, MotionEvent event)
			{
				startGame();

				return true;
			}
		});

		((ImageView) this.findViewById(this.getImageViewId())).setImageResource(this.getImageResourceId());
	}


	@Override
	public void finish()
	{
		if (null != this.theme && this.theme.isPlaying()) {
			this.theme.stop();
			this.theme.release();
			this.theme = null;
		}

		super.finish();
	}
}
